# Expectations of the Copy and Paste Action for Formulæ

## Menu
* Defining selection, copy, point and paste
* Motivation
* What's working thus far
* Expectations: types and examples
* One flexible approach?
* Future
## Definitions
* <img align="right" style="width:10em" src="clip-de-page.svg">Any piece of information or knowledge that can be selected
	* should be copyable
	* i.e. _put in a clipboard_
* could also be input
	* recreated or simply _pasted from the clipboard_
## Technically
* Within MacOSX, Windows, GNOME and others the clipboard is
* A record: content-types → array of bytes
* Applications are free to record whatever type they want
* Pasting: apps are expected to select the best type
* gotchas: 
	* there may be _parallel data_ (e.g. internal references)
	* agreement on content-types...
## So you want to copy?
* Antiquity n°1: Just copy text syntax
	* syntax match? try TeX with macros
* Antiquity n°2: you want standards? 
	* Use <span style="font-size:tiny">Edit : Copy special : Copy as MathML</span>
* Antiquity n°3: a universal language exists (e.g. Wolfram's)
	* The nifty function prime-check-with-a-hardware-chip-that-removes-your-privacy will not be available in OpenOffice soon
## Motivation
* Several tools, each with their specialty
	* need inter-application communication
* Facilitating the input is a key cognitive support
	* _It didn’t accept my answer as correct, despite clear syntax (checked by the syntax checker) and my answer being correct._
* Somehow, the issue was not observed
	* Internal copy and paste of course insures the quality of the copy
## Expectations


## Expectation: I am not dumb
* Users are fully able to understand the encoding differences
	* but refuse to be cognitively loaded with it
* E.g. differences of syntax or context
* Ok if it can't input half-a-fraction...
	* but should still do something useful!
## Expectation: Natural Selection
* Formulæ are often understood as text
	* horizontal selection typically natural
	* kind of ok for simple polynomials
* Feedback is key!
	* MathML selection miserable thus far (a pack of letters)
	* e.g. TeXmacs' tree-selection
* Q: is multiple selection display useful?
## Expectation: A single copy and paste
* Multiple copy operations are generally useless
	* E.g. _Copy special_, _Copy as..._
	* It should depend on where you go to
* Often used currently because users want to be control
	* Mathematicians who know the syntaxes
	* Persons who want a chance to hack the result
## Expectation: Choose the right thing
* Easy strategies:
	* Going to a text editor? plain text (or... TeX? Mathematica?)
	* Going to a text-processing? display formula, styled text, pictures
	* Going to a CAS? computable formula, s-expression, display formula, styled text? pictures?
	* Going to a dynamic geometry figure: i2g construction, computable formula, ...
* And, in all cases: internal data and proprietary format should take precedence (e.g. Maple has prepared something for Mathematica)
## A Surprisingly Complete Solution: the Wiris Input Editor
* The current Wiris Input Editor is in JavaScript
	* and edits formulæ for display only
* Any selection is reflected a MathML text (the only widely allowed format)
* Receiving applications can _sniff_ MathML and act accordingly
	* could contain computable and display formulæ
	* multiple formats (also TeX or differnt computing levels)
* Probably a temporary solution until MathML is accepted as safe
## Tracking expectations
* Expectations above are from our experience:
* But system makers know their users well too!
	* and they mostly ignore standards
* How can they systematically report?
	* Probably a wiki powered by a clipboard inspector
* Many many many surprises expected: e.g. style breaches, issues of translatations, representation transfers we did not think of
	* deep into mathematical competencies
## Conclusion
* Copy and paste still unpredictable
* Could be a game to teach students that they need to think a lot before c-n-p ing
	* Is this a matrix? _you'd better use a text editor's regexp to replace the brackets_
	* Is this a function definition? _Make it computable by assigning it..._
* Computers seem not there to help but to rob users' time.
	* Lots of natural expectations not assumed
	* Reporting could help


## Question time
Question guidelines:
* 2-3 minutes asking, one answer type
* one answer choice:
	* long individual: designated answerers
	* opinion: choose between a set of answers (raise hand)
	* vote: choose bteween agree or disagree
Some askers have been invited, others can come
	